::mods_registerMod("mod_turn_it_in", 1.0);
::mods_queue(null , null, function()
{
	::mods_hookNewObject("states/world/asset_manager", function (o)
	{
		local excluded_contracts =
		[
			"contract.patrol",
			"contract.escort_envoy"
		]
			
			
		while (!("update" in o)) o = o[o.SuperName];
		local update = o.update;		
		o.update = function(_worldState)
		{
			local activeContract = this.World.Contracts.getActiveContract();
			if (activeContract && this.World.FactionManager.getFaction(activeContract.getFaction()).m.Type == this.Const.FactionType.NobleHouse && excluded_contracts.find(activeContract.m.Type) == null && 
			(activeContract.getActiveState().ID == "Return" || (activeContract.m.Type == "contract.big_game_hunt" && activeContract.getActiveState().Flags.get("HeadsCollected") != 0)))
			{
				local contract_faction = this.World.FactionManager.getFaction(activeContract.getFaction())
				local towns = contract_faction.getSettlements()
				if (!activeContract.m.Flags.get("UpdatedBulletpoints"))
				{
					activeContract.m.BulletpointsObjectives.pop()
					if (activeContract.m.Type == "contract.big_game_hunt"){
						activeContract.m.BulletpointsObjectives.push("Return to any town of " + contract_faction.getName() + " to get paid")
					}
					else{
						activeContract.m.BulletpointsObjectives.push("Return to any town of " + contract_faction.getName())
					}
					activeContract.m.Flags.set("UpdatedBulletpoints", true)
					foreach (town in towns)
					{
						town.getSprite("selection").Visible = true;
					}
					this.World.State.getWorldScreen().updateContract(activeContract);
				}
				foreach (town in towns)
				{
					if (activeContract.isPlayerAt(town))
					{
						activeContract.m.Home = this.WeakTableRef(town)
						break
					}
				}				
			}
				
			update(_worldState)
		}

	})
	::mods_hookClass("contracts/contract", function (o)
	{
		
		while (!("onClear" in o)) o = o[o.SuperName];
		local onClear = o.onClear;		
		o.onClear = function()
		{
			if (this.isActive())
			{
				local contract_faction = this.World.FactionManager.getFaction(this.getFaction())
				local towns = contract_faction.getSettlements()
				foreach (town in towns)
				{
					town.getSprite("selection").Visible = false;
				}
			}
			onClear()
		}
		
		while (!("onDeserialize" in o)) o = o[o.SuperName];
		local onDeserialize = o.onDeserialize;		
		o.onDeserialize = function(_in)
		{
			onDeserialize( _in )
			if (this.m.Flags.get("UpdatedBulletpoints"))
			{

				local contract_faction = this.World.FactionManager.getFaction(this.getFaction())
				local towns = contract_faction.getSettlements()
				this.m.BulletpointsObjectives.pop()
				if (this.m.Type == "contract.big_game_hunt"){
					this.m.BulletpointsObjectives.push("Return to any town of " + contract_faction.getName() + " to get paid")
				}
				else{
					this.m.BulletpointsObjectives.push("Return to any town of " + contract_faction.getName())
				}
				foreach (town in towns)
				{
					town.getSprite("selection").Visible = true;
				}
				this.World.State.getWorldScreen().updateContract(this);
			}
		}
	})
				
})